//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
// CommonHelpers satellite library | Author: Sergei Y.Kitáev
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
using System;

#if !WASM
namespace CommonHelpers {
#else
namespace CommonHelpers.WASM {
#endif

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class HArgumentOutOfRangeExceptionCreator {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="ArgumentNullException" />
public static ArgumentOutOfRangeException Create(string message)
{
   HArgChecking.VerifyNotNull( message );
   return new ArgumentOutOfRangeException( null, message );
}
/// <exception cref="ArgumentNullException" />
public static ArgumentOutOfRangeException Create(string messageFmt,params object[] parameters)
{
   HArgChecking.VerifyNotNulls( messageFmt, parameters );
   return Create( HString.FormatAsText( messageFmt, parameters ) );
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="ArgumentNullException" />
public static ArgumentOutOfRangeException Create(string paramName,string message)
{
   HArgChecking.VerifyNotNulls( paramName, message );
   return new ArgumentOutOfRangeException( paramName, message );
}
/// <exception cref="ArgumentNullException" />
public static ArgumentOutOfRangeException Create( string paramName,
                                                  string messageFmt, params object[] parameters )
{
   HArgChecking.VerifyNotNulls( paramName, messageFmt, parameters );
   return Create( paramName, HString.FormatAsText( messageFmt, parameters ) );
}

//==================================================================================================

static HArgumentOutOfRangeExceptionCreator()
{
   CommonHelpers_Core.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // HArgumentOutOfRangeExceptionCreator
//**************************************************************************************************

} // CommonHelpers (.WASM)
